<?php
namespace Teknisa\EST\Modules\Produto\Controllers;

use Teknisa\EST\Modules\Produto\Services\Fiscal as FiscalService;
use Teknisa\EST\Modules\Produto\Services\ProdutoUtilities;
use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;

class Fiscal {
    
    protected $fiscalService;
    protected $utilities;
    protected $crudService;

    public function __construct(FiscalService $fiscalService, ProdutoUtilities $utilities, CrudService $crudService) {
        $this->fiscalService = $fiscalService;
        $this->utilities = $utilities;
        $this->crudService =$crudService;
    }

    public function saveFiscal(Row $request, Response $response) {
        $this->utilities->beginTransaction();
        try {
            $row = $request->getRow();
            $this->fiscalService->saveFiscal($row);
            $this->utilities->flush();
            $this->utilities->saveInProduto($row);
            $this->utilities->flush();
            $this->utilities->commit();
            $row['__is_new'] = false;
            $dataSet = new DataSet('produto', array($row));
            $response->setDataSets(array($dataSet));
        } catch (\Exception $e) {
            $this->utilities->rollBack();
			$response->setError(new Error($e->getMessage(), $e->getCode()));
		}
    }
    
}