var Est43000_ManutencaoDoUltimoCusto_Controller = function(EstUtil, templateManager, MessageService, ScreenService, General, ZhFilterPreferences) {

    let IDUTILALMOX, IDUTILLCESTQ, IDUTILLOTE;

    this.setNameLayout = function(args) {
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')) {
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL') {
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }
        else {
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };

    this.getFilialLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.preparaFiltroEFields = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            const { CDFILIAL, NMFILIAL, } = success.dataset.filial[0];

            rowsToSet.CDFILIAL = CDFILIAL;
            rowsToSet.NMFILIAL = NMFILIAL;
            rowsToSet.DTREFERENCIA = getLocalVar("DTPROCESSA");
            rowsToSet.DTPROCESSA = getLocalVar("DTPROCESSA");

            ZhFilterPreferences.setOriginalFilter(widget.id, rowsToSet);
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function() {
                let filtro = templateManager.container.getActiveWidget();
                this.validaFilial(filtro);
            }.bind(this));
        }.bind(this));
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    this.validaFilial = function(widget, fieldName) {
        const currentRow = widget.currentRow;
        const widgetProduto = templateManager.container.getWidget("widgetProduto");

        const almoxField = widget.getField('DSALMOXARIFE');
        const localField = widget.getField('DSLOCALESTOQ');
        const almoxFieldProduto = widgetProduto.getField('DSALMOXARIFE');
        const localFieldProduto = widgetProduto.getField('DSLOCALESTOQ');
        const almoxDestField = widget.getField('DSALMOXARIFEDEST');
        const localDestField = widget.getField('DSLOCALESTOQDEST');

        let cdfilial = currentRow.CDFILIAL;

        if (cdfilial) {
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ];

            General.callRestEngine('est_ajuste#/crud/paramfilial', 'FilterData', filter).then(function(success) {
                const {
                    DTPROCESSA,
                    IDCTRLESTQ,
                    IDUTILALMOX: controlaAlmox,
                    IDUTILLCESTQ: controlaLocal,
                    IDUTILLOTE: controlaLote
                } = success.dataset.paramfilial[0];

                currentRow.DTPROCESSA = DTPROCESSA;
                IDUTILALMOX = controlaAlmox;
                IDUTILLCESTQ = controlaLocal;
                IDUTILLOTE = controlaLote;

                if (IDCTRLESTQ === 'S') {
                    if (IDUTILALMOX === 'S') {
                        if (fieldName === 'NMFILIALDEST') {
                            almoxDestField.readOnly = false;
                            currentRow.controlaLocalDest = IDUTILLCESTQ == 'S' ? true : false;
                        }
                        else {
                            almoxField.readOnly = false;
                            almoxField.validations = { "required": { "message": "Campo Obrigatório!" } };
                            almoxFieldProduto.filterProperties.readOnly = false;
                            almoxFieldProduto.filterProperties.validations = { "required": { "message": "Campo Obrigatório!" } };
                        }

                        almoxField.dataSourceFilter.forEach(function(fil) {
                            if (fil.name == "CDFILIAL")
                                fil.value = currentRow.CDFILIAL;
                        });
                    }
                    else {
                        MessageService.showMessageByCode('CONTROLA_ALMOX');
                        localField.readOnly = true;
                        almoxField.readOnly = true;
                        delete almoxField.validations;

                        localFieldProduto.filterProperties.readOnly = true;
                        almoxFieldProduto.filterProperties.readOnly = true;
                        delete almoxFieldProduto.filterProperties.validations;

                        if (almoxDestField) {
                            almoxDestField.readOnly = true;
                            localDestField.readOnly = true;
                            almoxDestField.reload();
                            localDestField.reload();
                        }
                    }
                    almoxField.reload();
                    localField.reload();
                }
                else {
                    if (fieldName === 'NMFILIALDEST') {
                        currentRow.CDFILIALDEST = '';
                        currentRow.NMFILIALDEST = '';
                        MessageService.showMessageByCode('CONTROLA_ESTOQUE');
                        currentRow.controlaLocalDest = false;
                    }
                    else {
                        currentRow.CDFILIAL = '';
                        currentRow.NMFILIAL = '';
                    }
                }
                localField.readOnly = true;
                delete localField.validations;

                localFieldProduto.filterProperties.readOnly = true;
                delete localFieldProduto.filterProperties.validations;
            });
        }
        else {
            almoxField.readOnly = true;
            localField.readOnly = true;

            almoxFieldProduto.filterProperties.readOnly = true;
            localFieldProduto.filterProperties.readOnly = true;
        }
        currentRow.CDALMOXARIFE = '';
        currentRow.DSALMOXARIFE = '';
        currentRow.CDLOCALESTOQ = '';
        currentRow.DSLOCALESTOQ = '';
    };

    this.setReadOnlyLocal = function(widget, fieldName) {
        const {
            DSALMOXARIFE,
            IDUTILLCESTQ
        } = widget.currentRow;

        const localField = widget.getField('DSLOCALESTOQ');
        const localDestField = widget.getField('DSLOCALESTOQDEST');

        if (DSALMOXARIFE) {
            if (fieldName === 'DSALMOXARIFEDEST') {
                if (IDUTILLCESTQ == 'S')
                    localDestField.readOnly = false;
            }
            else {
                if (IDUTILLCESTQ == 'S') {
                    localField.readOnly = false;
                    localField.validations = { "required": { "message": "Campo Obrigatório!" } };
                    localField.filterProperties.readOnly = false;
                    localField.filterProperties.validations = { "required": { "message": "Campo Obrigatório!" } };
                }
                else {
                    localField.readOnly = true;
                    delete localField.validations;
                    localField.filterProperties.readOnly = true;
                    delete localField.filterProperties.validations;
                }
            }
            localField.dataSourceFilter.forEach(function(fil) {
                switch (fil.name) {
                    case 'CDFILIAL':
                        fil.value = widget.currentRow.CDFILIAL;
                        break;

                    case 'CDALMOXARIFE':
                        fil.value = widget.currentRow.CDALMOXARIFE;
                        break;
                }
            });
        }
        else {
            if (fieldName === 'DSALMOXARIFEDEST') {
                if (IDUTILLCESTQ == 'N') {
                    localDestField.readOnly = true;
                }
                widget.currentRow.CDLOCALESTOQDEST = '';
                widget.currentRow.DSLOCALESTOQDEST = '';
            }
            else {
                if (IDUTILLCESTQ == 'S') {
                    localField.readOnly = false;
                    localField.validations = { "required": { "message": "Campo Obrigatório!" } };
                    localField.filterProperties.readOnly = false;
                    localField.filterProperties.validations = { "required": { "message": "Campo Obrigatório!" } };
                }
                else {
                    localField.readOnly = true;
                    delete localField.validations;
                    localField.filterProperties.readOnly = true;
                    delete localField.filterProperties.validations;
                }
                widget.currentRow.CDLOCALESTOQ = '';
                widget.currentRow.DSLOCALESTOQ = '';
            }
        }
    };

    this.FilterProdIni = function(args) {
        var widget = args.owner.field.widget;
        var row = widget.currentRow;
        var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
        if (!prodIniIsSet) {
            widget.currentRow.NMPRODFIN = '';

        }
        widget.getField('NMPRODFIN').readOnly = !prodIniIsSet;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !prodIniIsSet;
    };

    this.FilterProdFin = function(args) {
        var widget = args.owner.field.widget;
        var row = widget.currentRow;
        var prodFinIsSet = this.fieldIsSet(row.CDPRODFIN);
        if (prodFinIsSet) {
            if (row.CDPRODINI > row.P_PRODFIN) {
                MessageService.showMessageByCode('PRODUTO_FINAL_INVALIDO');
                return 0;
            }
        }
        widget.reload();
    };

    this.fieldIsSet = function(fieldValue) {
        if (fieldValue) return true;
        else return false;
    };

    this.openPopup = function(widgetName) {
        var widgetPopup = templateManager.container.getWidget(widgetName);
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
    };

    this.saveNewManutencao = function(widget) {
        if (widget.isValid()) {
            if (!widget.currentRow.NRLOTEESTQ || widget.currentRow.NRLOTEESTQ === ' ') {
                widget.currentRow.NRLOTEESTQ = ' ';
                widget.currentRow.NRSUBLOTE = ' ';
            }

            General.callRestEngine('est_ajuste#/saveManutencao', 'Row', widget.currentRow).then(function(success) {
                    if (widget.currentRow.__is_new) {
                        ScreenService.goBack();
                        widget.reload();
                    }
                    else {
                        ScreenService.closePopup();
                        widget.view();
                        widget.reload();
                    }
                }.bind(this),
                function(callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };

    this.validaData = function(widget) {
        if (widget.currentRow.DTPROCESSA) {
            if (widget.currentRow.DTPROCESSA < widget.currentRow.DTCUSTCMPPRO) {
                MessageService.showMessageByCode('DATA_ERROR');
            }
        }
    };

    this.adicionar = function(widget) {
        if (EstUtil.onValidateFilterRequirement(widget)) {
            this.validaFilial(EstUtil.getFilterWidget(widget));
            return;
        }
        var rowFilter = widget.appliedFilter.FILTER_ROW;
        if (rowFilter.CDFILIAL) {
            widget.newRow();
            var Data = new Date();
            var dataDia;
            var dataMonth = Data.getMonth() + 1;
            if (Data.getDate() < 10) dataDia = '0' + Data.getDate();
            else dataDia = Data.getDate();
            if (dataMonth < 10) dataMonth = '0' + (dataMonth);
            var dataAtual = dataDia + '/' + dataMonth + '/' + Data.getFullYear();
            widget.currentRow.DTCUSTCMPPRO = dataAtual;
            widget.currentRow.CDFILIAL = rowFilter.CDFILIAL;
            widget.currentRow.CDALMOXARIFE = rowFilter.CDALMOXARIFE || ' ';
            widget.currentRow.CDLOCALESTOQ = rowFilter.CDLOCALESTOQ || ' ';
            widget.currentRow.DTPROCESSA = rowFilter.DTPROCESSA;
        }
        else {
            MessageService.showMessageByCode('ADICIONAR_ERROR');
        }
    };

    this.controlaLoteProduto = function(widget) {
        if (widget.currentRow.NMPRODUTO) {
            if (IDUTILLOTE == 'S') {
                widget.currentRow.NRLOTEESTQ = ' ';
                widget.getField('NRLOTEESTQ').reload();
                widget.getField('NRLOTEESTQ').readOnly = false;
            }
            else {
                widget.currentRow.NRLOTEESTQ = ' ';
                widget.getField('NRLOTEESTQ').reload();
                widget.getField('NRLOTEESTQ').readOnly = true;
            }
        }
        else {
            widget.currentRow.NRLOTEESTQ = ' ';
            widget.getField('NRLOTEESTQ').reload();
            widget.currentRow.NRLOTEESTQ.readOnly = true;
        }
    };

    this.saveImportacao = function(widget) {
        if (widget.isValid()) {
            var row = widget.currentRow;
            row.CDNVPRODUTO = General.getLevelByMask('CDPICTPROD', 1).length;
            if (row.CDFILIALDEST == row.CDFILIAL && row.CDALMOXARIFE == row.CDALMOXARIFEDEST && row.CDLOCALESTOQDEST == row.CDLOCALESTOQDEST) {
                MessageService.showMessageByCode('ORI_DEST_IGUAL');
            }
            else {
                MessageService.confirmMessageByCode("CONFIRMA_IMPORTACAO").then(() => {
                    General.callRestEngine('est_ajuste#/importaUltimoCusto', 'Row', row).then(() => {
                            var widgetActivate = templateManager.container.getWidget('widgetProduto');
                            var widgetPopup = templateManager.container.getWidget('IMPORTACUSTO');
                            ScreenService.goBack();
                            widgetPopup.isVisible = false;
                            widgetPopup.currentRow = {};
                            ScreenService.closePopup(widgetPopup);
                            MessageService.showMessageByCode('CUSTO_IMPORTADO');
                            widgetActivate.activate();
                            widgetActivate.reload();
                            ScreenService.closePopup();
                        },
                        function(callback) {
                            if (callback.data) {
                                ScreenService.showMessage(callback.data.error);
                            }
                        }
                    );

                });
            }
        }
    };

    this.atualizaUltimoCusto = function(widget) {
        if (widget.isValid()) {
            MessageService.confirmMessageByCode('CONFIRMA_ATUALIZACAO').then(() => {
                var row = widget.currentRow;
                row.CDNVPRODUTO = General.getLevelByMask('CDPICTPROD', 1).length;
                General.callRestEngine('est_ajuste#/atualizaUltimoCusto', 'Row', row).then(() => {
                        var widgetActivate = templateManager.container.getWidget('widgetProduto');
                        var widgetPopup = templateManager.container.getWidget('ATUALIZACUSTO');
                        widgetPopup.isVisible = false;
                        widgetPopup.currentRow = {};
                        ScreenService.closePopup(widgetPopup);
                        MessageService.showMessageByCode('CUSTO_ATUALIZADO');
                        widgetActivate.activate();
                        widgetActivate.reload();
                        ScreenService.closePopup();

                    },
                    function(callback) {
                        if (callback.data) {
                            MessageService.showMessageByCode("FINANCEIRO_ERROR");
                        }
                    }
                );
            });
        }
    };

    this.closePopup = function(widgetName, popupName) {
        var widget = templateManager.container.getWidget(popupName);
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget(widgetName);
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };

    this.changeFilter = function(widget, preference) {
        let filterRow = preference.FILTER_ROW;
        filterRow.CDPRODFIN = filterRow.CDPRODFIN.padEnd(20, "z");

        let filtro = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filterRow.CDFILIAL ? filterRow.CDFILIAL : null
            },
            {
                "name": "DTREFERENCIA",
                "operator": "=",
                "value": filterRow.DTREFERENCIA ? filterRow.DTREFERENCIA : null
            },
            {
                "name": "CDALMOXARIFE",
                "operator": "=",
                "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : null
            },
            {
                "name": "CDLOCALESTOQ",
                "operator": "=",
                "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : null
            },
            {
                "name": "CDPRODINI",
                "operator": "=",
                "value": filterRow.CDPRODINI ? filterRow.CDPRODINI : null
            },
            {
                "name": "CDPRODFIN",
                "operator": "=",
                "value": filterRow.CDPRODFIN ? filterRow.CDPRODFIN : null
            }
        ];

        widget.dataSourceFilter = filtro;
        widget.reload();

    };

    this.actionsHandler = function(widget) {
        if (IDUTILLOTE == "S")
            General.setDisableAction("Novo", widget.name);
        else
            General.setEnableAction("Novo", widget.name);

        widget.reload();
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('Est43000_ManutencaoDoUltimoCusto_Controller', Est43000_ManutencaoDoUltimoCusto_Controller);
});
