function Est12000_EmissaoDosLancamentosDeEntrada_Controller(EstUtil, ScreenService, General, templateManager,ZhFilterPreferences, Est12000_EmissaoDosLancamentosDeEntrada_Service) {

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        let rowsToSet  = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = [success.dataset.filial[0].CDFILIAL];
            rowsToSet.NMFILIAL = [success.dataset.filial[0].NMFILIAL];
            ZhFilterPreferences.openFilterWidget(widget,rowsToSet).then(function(success) {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NMFILIAL").reload();
                this.verAlmoxEstoque(templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions'));
            }.bind(this));
        }.bind(this));
        
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.getFilialLogada = function() {
    var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
	    ];
    return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    // Habilita/Desabilita Almoxarifado e Localização
    this.verAlmoxEstoque = function(args){
        
        
        let widget = templateManager.container.getActiveWidget();
        
        if(widget.name != 'zhFilterPreferencesSelectConditions'){
            widget = args;
        }
        
        Est12000_EmissaoDosLancamentosDeEntrada_Service.getParamFilialData(widget).then(() =>{
            
            let almoxField = widget.getField('DSALMOXARIFE');
            let LocalField = widget.getField('DSLOCALESTOQ');
            let cdAlmoxField = widget.getField('CDALMOXARIFE');
            let cdLocalEstField = widget.getField('CDLOCALESTOQ');
            
            widget.currentRow.CDALMOXARIFE = cdAlmoxField.value() ? cdAlmoxField.value() : "";
            
            //verifica almoxarifado
            if(widget.currentRow.IDUTILALMOX === 'N'){
                almoxField.readOnly = true;
                almoxField.clearValue();
                cdAlmoxField.clearValue("");
            }else{
                almoxField.readOnly = false;
            }
            
            //verifica local do estoque
            if(widget.currentRow.IDUTILLCESTQ === 'N'){
                LocalField.readOnly = true;
                LocalField.clearValue();
                cdLocalEstField.clearValue("");
            }else{
                cdLocalEstField.clearValue();
                LocalField.readOnly = false;
            }
            
            this.checkDataFilter(widget);
            
        });
    };
    
	// Realiza a limpeza de valores do filtro caso a filial seja mudada
    this.clearFieldsOnChangeFilial = function(widget){
        let fields = [
            "DSALMOXARIFE",
            "DSLOCALESTOQ",
            "CDALMOXARIFE",
            "CDLOCALESTOQ",
            "INTERVALO",
            "CDPRODINI",
            "CDPRODFIN",
            "NMPRODINI",
            "NMPRODFIN"
            ];
        
        fields.forEach((field)=>{
            let fieldToClear = widget.getField(field);
            fieldToClear.clearValue("");
            
            if(fieldToClear.name === "DSALMOXARIFE" || fieldToClear.name === "DSLOCALESTOQ" ||
            fieldToClear.name === "NMPRODINI" || fieldToClear.name === "NMPRODFIN"){
                fieldToClear.reload();
            }
        });
    };
    
    // redefine filtro com parametros corretos a serem enviados para o backend
    this.changeFilter = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        
        var tamanhoMask = getLocalVar('CDPICTPROD').replace(/\./g,'').length;
        filterRow.CDPRODFIN = filterRow.CDPRODFIN? filterRow.CDPRODFIN : "";
        var tamanho = tamanhoMask - filterRow.CDPRODFIN.length;
        
        for(var i = 0; i < tamanho; i++){
        	filterRow.CDPRODFIN = filterRow.CDPRODFIN+"Z";
        }

        var filtro= [
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value": filterRow.CDFILIAL
            },
            {
                "name":"CDALMOXARIFE",
                "operator":"=",
                "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : null
            },
            {
                "name":"CDLOCALESTOQ",
                "operator":"=",
                "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : null
            },
            {
                "name":"DTINICIAL",
                "operator":"=",
                "value": filterRow.INTERVALO ? filterRow.INTERVALO.start : null
            },
            {
                "name":"DTFINAL",
                "operator":"=",
                "value": filterRow.INTERVALO ? filterRow.INTERVALO.end : null
            },
            {
                "name":"CDPRODINI",
                "operator":"=",
                "value": filterRow.CDPRODINI ? filterRow.CDPRODINI : null
            },
            {
                "name":"CDPRODFIN",
                "operator":"=",
                "value": filterRow.CDPRODFIN ? filterRow.CDPRODFIN : null
            },
            {
                "name":"INTERVALO",
                "operator":"=",
                "value": null
            }
        ];
        
        
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };
    
	// Realiza a limpeza de valores do filtro caso os campos de Produtos seja modificado
	this.clearFieldsOnChangeProduto = function(field){
        let widget = field.widget;
        let fieldProdIni = widget.getField('NMPRODINI');
        let fieldProdFim = widget.getField('NMPRODFIN');
        let fieldGrupProd = widget.getField('NMGRUPPROD');
        
        switch(field.name){
            case 'NMPRODFIN':
            case 'NMPRODINI':
                fieldProdIni.validations = {"required": true};
                fieldProdFim.validations = {"required": true};
                delete fieldGrupProd.validations;
                widget.currentRow.NMGRUPPROD = '';
                break;
            case 'NMGRUPPROD':
                widget.currentRow.NMPRODINI = '';
                widget.currentRow.NMPRODFIN = '';
                delete fieldProdIni.validations;
                delete fieldProdFim.validations;
                fieldGrupProd.validations = {"required": true};
        }
        
    };
    
    this.checkDataFilter = function(args){
        
        let widget = templateManager.container.getActiveWidget();
        
        if(widget.name != 'zhFilterPreferencesSelectConditions'){
            widget = args;
        }
        
        let LocalField = widget.getField('DSLOCALESTOQ');
        let cdLocalEstField = widget.getField('CDLOCALESTOQ');
        
        if(widget.currentRow.IDUTILALMOX === 'S' && widget.currentRow.IDUTILLCESTQ === 'S'){
            if(widget.currentRow.CDALMOXARIFE !== ""){
                LocalField.validations = {"required": {"message": "Campo Obrigatório"}};
                LocalField.readOnly = false;
            }else{
                LocalField.clearValue();
                cdLocalEstField.clearValue();
                delete LocalField.validations;
                LocalField.readOnly = true;
            }
            
            LocalField.reload();
        }
        
        if(widget.currentRow.IDUTILALMOX === 'S' && widget.currentRow.IDUTILLCESTQ === 'N'){
            if(widget.currentRow.CDALMOXARIFE !== ""){
                cdLocalEstField.value(' ');
            }else{
                cdLocalEstField.clearValue("");
            }
        }
        
    };
    
    this.checkProductRange = function(field) {
        var currentRow = field.widget.currentRow;
      
        if(currentRow.CDPRODINI && currentRow.CDPRODFIN) {
            var compproduto = (currentRow.CDPRODFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if(!General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;

                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        } 
    };
    
    
}


Configuration(function(ContextRegister){
    ContextRegister.register('Est12000_EmissaoDosLancamentosDeEntrada_Controller', Est12000_EmissaoDosLancamentosDeEntrada_Controller);
});